2 # Copyright 2014 The Chromium Authors. All rights reserved.
3 # Use of this source code is governed by a BSD-style license that can be
4 # found in the LICENSE file.
6 # URL from which the latest version of this script can be downloaded.
7 script_url
="http://src.chromium.org/svn/trunk/src/tools/android/adb_remote_setup.sh"
9 # Replaces this file with the latest version of the script and runs it.
11 local script="${BASH_SOURCE[0]}"
12 local new_script
="${script}.new"
13 local updater_script
="${script}.updater"
14 curl
-sSf -o "$new_script" "$script_url" ||
return
15 chmod +x
"$new_script" ||
return
17 # Replace this file with the newly downloaded script.
18 cat > "$updater_script" << EOF
20 if mv "$new_script" "$script"; then
21 rm -- "$updater_script"
23 echo "Note: script update failed."
25 ADB_REMOTE_SETUP_NO_UPDATE=1 exec /bin/bash "$script" $@
27 exec /bin
/bash
"$updater_script" "$@"
30 if [[ "$ADB_REMOTE_SETUP_NO_UPDATE" -ne 1 ]]; then
31 update-self
"$@" ||
echo 'Note: script update failed'
34 if [[ $# -ne 1 && $# -ne 2 ]]; then
36 Usage: adb_remote_setup.sh REMOTE_HOST [REMOTE_ADB]
38 Configures adb on a remote machine to communicate with a device attached to the
39 local machine. This is useful for installing APKs, running tests, etc while
43 REMOTE_HOST hostname of remote machine
44 REMOTE_ADB path to adb on the remote machine (you can omit this if adb is in
45 the remote host's path)
51 remote_adb
="${2:-adb}"
53 # Ensure adb is in the local machine's path.
54 if ! which adb
>/dev
/null
; then
55 echo "error: adb must be in your local machine's path."
59 if which kinit
>/dev
/null
; then
60 # Allow ssh to succeed without typing your password multiple times.
64 # Ensure local and remote versions of adb are the same.
65 remote_adb_version
=$
(ssh "$remote_host" "$remote_adb version")
66 local_adb_version
=$
(adb version
)
67 if [[ "$local_adb_version" != "$remote_adb_version" ]]; then
69 echo "WARNING: local adb is not the same version as remote adb." >&2
70 echo "This should be fixed since it may result in protocol errors." >&2
71 echo " local adb: $local_adb_version" >&2
72 echo " remote adb: $remote_adb_version" >&2
77 # Kill the adb server on the remote host.
78 ssh "$remote_host" "$remote_adb kill-server"
80 # Start the adb server locally.
83 # Forward various ports from the remote host to the local host:
87 # 9041: search by image server
89 # 10000: net unittests
90 # 10201: net unittests
92 -R 5037:localhost
:5037 \
93 -L 8001:localhost
:8001 \
94 -L 9031:localhost
:9031 \
95 -L 9041:localhost
:9041 \
96 -L 9051:localhost
:9051 \
97 -R 10000:localhost
:10000 \
98 -R 10201:localhost
:10201 \